/**
  ******************************************************************************
  * File Name          : main.c
  * Description        : Main program body
  ******************************************************************************
  * This notice applies to any and all portions of this file
  * that are not between comment pairs USER CODE BEGIN and
  * USER CODE END. Other portions of this file, whether
  * inserted by the user or by software development tools
  * are owned by their respective copyright owners.
  *
  * Copyright (c) 2017 STMicroelectronics International N.V.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted, provided that the following conditions are met:
  *
  * 1. Redistribution of source code must retain the above copyright notice,
  *    this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright notice,
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
  * 3. Neither the name of STMicroelectronics nor the names of other
  *    contributors to this software may be used to endorse or promote products
  *    derived from this software without specific written permission.
  * 4. This software, including modifications and/or derivative works of this
  *    software, must execute solely and exclusively on microcontroller or
  *    microprocessor devices manufactured by or for STMicroelectronics.
  * 5. Redistribution and use of this software other than as permitted under
  *    this license is void and will automatically terminate your rights under
  *    this license.
  *
  * THIS SOFTWARE IS PROVIDED BY STMICROELECTRONICS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS, IMPLIED OR STATUTORY WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  * PARTICULAR PURPOSE AND NON-INFRINGEMENT OF THIRD PARTY INTELLECTUAL PROPERTY
  * RIGHTS ARE DISCLAIMED TO THE FULLEST EXTENT PERMITTED BY LAW. IN NO EVENT
  * SHALL STMICROELECTRONICS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
  * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f1xx_hal.h"
#include "usb_device.h"
#include "usbd_hid.h"

/* USER CODE BEGIN Includes */

dev_mode_t MODE;
/* USER CODE END Includes */

/* Private variables ---------------------------------------------------------*/
TIM_HandleTypeDef htim3;
TIM_HandleTypeDef htim4;

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/
const uint16_t PWM[256] = {60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 61, 61, 61, 61, 61, 61, 61, 61, 61, 62, 62, 62, 62, 62, 62, 63, 63, 63, 63, 64, 64, 64, 64, 65, 65, 65, 66, 66, 67, 67, 67, 68, 68, 69, 69, 70, 70, 71, 71, 72, 73, 73, 74, 75, 75, 76, 77, 77, 78, 79, 80, 81, 82, 83, 83, 84, 85, 86, 87, 88, 90, 91, 92, 93, 94, 95, 97, 98, 99, 101, 102, 103, 105, 106, 108, 109, 111, 112, 114, 116, 117, 119, 121, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 144, 147, 149, 151, 154, 156, 158, 161, 163, 166, 169, 171, 174, 177, 179, 182, 185, 188, 191, 194, 197, 200, 203, 206, 209, 212, 216, 219, 222, 226, 229, 233, 236, 240, 244, 248, 251, 255, 259, 263, 267, 271, 275, 279, 283, 288, 292, 296, 301, 305, 310, 314, 319, 323, 328, 333, 338, 343, 348, 353, 358, 363, 368, 373, 379, 384, 389, 395, 400, 406, 412, 417, 423, 429, 435, 441, 447, 453, 459, 466, 472, 478, 485, 491, 498, 504, 511, 518, 525, 532, 539, 546, 553, 560, 567, 575, 582, 589, 597, 604, 612, 620, 628, 636, 644, 652, 660, 668, 676, 684, 693, 701, 710, 718, 727, 736, 745, 754, 763, 772, 781, 790, 800, 809, 818, 828, 838, 847, 857, 867, 877, 887, 897, 907, 918, 928, 939, 949, 960, 970, 981};
volatile uint8_t touch = 0;
volatile int32_t SW0_DEB = -1;
volatile int32_t SW1_DEB = -1;
volatile int32_t SW2_DEB = -1;
volatile int32_t SW3_DEB = -1;
/* USER CODE END PV */
/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_TIM3_Init(void);
static void MX_TIM4_Init(void);
void HAL_TIM_MspPostInit(TIM_HandleTypeDef *htim);


/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/
void ButtonTask(void);
void EncoderTask(void);
void LEDTask(void);
void wheel(int8_t change);
void media(uint8_t change);
void changeDevice(void);
void runSpotify(void);
void runChrome(void);
void runCalc(void);
/* USER CODE END PFP */

/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

int main(void) {

  /* USER CODE BEGIN 1 */
  /* USER CODE END 1 */

  /* MCU Configuration----------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_TIM3_Init();
  MX_TIM4_Init();
  MX_USB_DEVICE_Init();

  /* USER CODE BEGIN 2 */
  HAL_TIM_PWM_Start(&htim3,TIM_CHANNEL_1);
  HAL_TIM_PWM_Start(&htim3,TIM_CHANNEL_2);
  HAL_TIM_PWM_Start(&htim3,TIM_CHANNEL_3);

  HAL_TIM_Encoder_Start(&htim4,TIM_CHANNEL_ALL);

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1) {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
    EncoderTask();
    LEDTask();
    ButtonTask();
  }
  /* USER CODE END 3 */

}
void ButtonTask(void){
    if(SW0_DEB != -1){
      if(SW0_DEB > 0){ SW0_DEB--; }
      else if(!HAL_GPIO_ReadPin(SW0_GPIO_Port,SW0_Pin)){
        if(MODE == USER) {
          MODE = MEDIA;
        } else {
          MODE++;
        }
        SW0_DEB = -1;
      }
    }

    if(SW1_DEB != -1){
      if(SW1_DEB > 0){ SW1_DEB--; }
      else if(!HAL_GPIO_ReadPin(SW1_GPIO_Port,SW1_Pin)){
        media(MUTE);
        media(0);
        SW1_DEB = -1;
      }
    }

    if(SW2_DEB != -1){
      if(SW2_DEB > 0){ SW2_DEB--; }
      else if(!HAL_GPIO_ReadPin(SW2_GPIO_Port,SW2_Pin)){
        switch(MODE) {
          case MEDIA:
            changeDevice();
            break;
          case SPOTIFY:
            media(PLAY);
            media(0);
            break;
          case USER:
            runChrome();
            break;
          }
        SW2_DEB = -1;
      }
    }

    if(SW3_DEB != -1){
      if(SW3_DEB > 0){ SW3_DEB--; }
      else if(!HAL_GPIO_ReadPin(SW3_GPIO_Port,SW3_Pin)){
        switch(MODE) {
          case MEDIA:
            runSpotify();
            MODE = SPOTIFY;
            break;
          case SPOTIFY:
            media(NEXT);
            media(0);
            break;

          case USER:
            runCalc();
            break;
        }
        SW3_DEB = -1;
      }
    }
}
void EncoderTask(void) {
  static uint32_t delay = 18000;
  uint16_t i;
  static uint16_t li;

  delay--;
  if(delay == 0) {
    delay = 18000;
    i = TIM4->CNT ;

    if(li - i >= THRESHOLD) {
      switch(MODE) {
      case MEDIA:
      case SPOTIFY:
        media(VOL_UP);
        break;
      case USER:
        wheel(1);
        break;
      }

      li = i;
    } else if(i - li >= THRESHOLD) {
      switch(MODE) {
      case MEDIA:
      case SPOTIFY:
        media(VOL_DOWN);
        break;
      case USER:
        wheel(-1);
        break;
      }
      li = i;
    }
  }
}
void LEDTask(void) {
  static int32_t delay = 24000;
  static uint16_t color = 1;
  static uint8_t smer = 1;
  uint8_t intensity = SLOW_BLINK_INTENSITY;

  delay--;
  if(touch == 1) {
    delay -= FAST_BLINK_SPEED;
    intensity = FAST_BLINK_INTENSITY;
  }
  if(delay <= 0) {
    delay = 24000;
    if(smer) {
      switch(MODE) {
      case MEDIA:
        __HAL_TIM_SET_COMPARE(&htim3,RED_Channel,0);
        __HAL_TIM_SET_COMPARE(&htim3,GREEN_Channel,0);
        __HAL_TIM_SET_COMPARE(&htim3,BLUE_Channel,(intensity / 100.0) * PWM[color++]);
        break;

      case SPOTIFY:
        __HAL_TIM_SET_COMPARE(&htim3,RED_Channel,(0.15 * intensity / 100.0) * PWM[color]);
        __HAL_TIM_SET_COMPARE(&htim3,GREEN_Channel,(intensity / 100.0) * PWM[color]);
        __HAL_TIM_SET_COMPARE(&htim3,BLUE_Channel,(0.15 * intensity / 100.0) * PWM[color++]);
        break;

      case USER:
        __HAL_TIM_SET_COMPARE(&htim3,RED_Channel,(intensity / 100.0) * PWM[color]);
        __HAL_TIM_SET_COMPARE(&htim3,GREEN_Channel,0);
        __HAL_TIM_SET_COMPARE(&htim3,BLUE_Channel,(intensity / 100.0) * PWM[color++]);
        break;
      }

      if(color >= 255) {
        smer = 0;
      }
    } else {
      switch(MODE) {
      case MEDIA:
        __HAL_TIM_SET_COMPARE(&htim3,RED_Channel,0);
        __HAL_TIM_SET_COMPARE(&htim3,GREEN_Channel,0);
        __HAL_TIM_SET_COMPARE(&htim3,BLUE_Channel,(intensity / 100.0) * PWM[color--]);
        break;

      case SPOTIFY:
        __HAL_TIM_SET_COMPARE(&htim3,RED_Channel,(0.15 * intensity / 100.0) * PWM[color]);
        __HAL_TIM_SET_COMPARE(&htim3,GREEN_Channel,(intensity / 100.0) * PWM[color]);
        __HAL_TIM_SET_COMPARE(&htim3,BLUE_Channel,(0.15 * intensity / 100.0) * PWM[color--]);
        break;

      case USER:
        __HAL_TIM_SET_COMPARE(&htim3,RED_Channel,(intensity / 100.0) * PWM[color]);
        __HAL_TIM_SET_COMPARE(&htim3,GREEN_Channel,0);
        __HAL_TIM_SET_COMPARE(&htim3,BLUE_Channel,(intensity / 100.0) * PWM[color--]);
        break;
      }
      if(color <= 0) {
        smer = 1;
      }
    }
  }

}
/** System Clock Configuration
*/
void SystemClock_Config(void) {

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;
  RCC_PeriphCLKInitTypeDef PeriphClkInit;

  /**Initializes the CPU, AHB and APB busses clocks
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  /**Initializes the CPU, AHB and APB busses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                                |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_USB;
  PeriphClkInit.UsbClockSelection = RCC_USBCLKSOURCE_PLL_DIV1_5;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  /**Configure the Systick interrupt time
  */
  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);

  /**Configure the Systick
  */
  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}

/* TIM3 init function */
static void MX_TIM3_Init(void) {

  TIM_MasterConfigTypeDef sMasterConfig;
  TIM_OC_InitTypeDef sConfigOC;

  htim3.Instance = TIM3;
  htim3.Init.Prescaler = 71;
  htim3.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim3.Init.Period = 999;
  htim3.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim3.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_PWM_Init(&htim3) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim3, &sMasterConfig) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  sConfigOC.OCMode = TIM_OCMODE_PWM1;
  sConfigOC.Pulse = 0;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
  sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
  if (HAL_TIM_PWM_ConfigChannel(&htim3, &sConfigOC, TIM_CHANNEL_1) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  if (HAL_TIM_PWM_ConfigChannel(&htim3, &sConfigOC, TIM_CHANNEL_2) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  if (HAL_TIM_PWM_ConfigChannel(&htim3, &sConfigOC, TIM_CHANNEL_3) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  HAL_TIM_MspPostInit(&htim3);

}

/* TIM4 init function */
static void MX_TIM4_Init(void) {

  TIM_Encoder_InitTypeDef sConfig;
  TIM_MasterConfigTypeDef sMasterConfig;

  htim4.Instance = TIM4;
  htim4.Init.Prescaler = 1;
  htim4.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim4.Init.Period = 10000;
  htim4.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim4.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  sConfig.EncoderMode = TIM_ENCODERMODE_TI12;
  sConfig.IC1Polarity = TIM_ICPOLARITY_FALLING;
  sConfig.IC1Selection = TIM_ICSELECTION_DIRECTTI;
  sConfig.IC1Prescaler = TIM_ICPSC_DIV2;
  sConfig.IC1Filter = 15;
  sConfig.IC2Polarity = TIM_ICPOLARITY_RISING;
  sConfig.IC2Selection = TIM_ICSELECTION_DIRECTTI;
  sConfig.IC2Prescaler = TIM_ICPSC_DIV2;
  sConfig.IC2Filter = 15;
  if (HAL_TIM_Encoder_Init(&htim4, &sConfig) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim4, &sMasterConfig) != HAL_OK) {
    _Error_Handler(__FILE__, __LINE__);
  }

}

/** Configure pins as
        * Analog
        * Input
        * Output
        * EVENT_OUT
        * EXTI
*/
static void MX_GPIO_Init(void) {

  GPIO_InitTypeDef GPIO_InitStruct;

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pins : SW0_Pin SW1_Pin SW2_Pin SW3_Pin */
  GPIO_InitStruct.Pin = SW0_Pin|SW1_Pin|SW2_Pin|SW3_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_FALLING;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : CAP_IN_Pin */
  GPIO_InitStruct.Pin = CAP_IN_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING_FALLING;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(CAP_IN_GPIO_Port, &GPIO_InitStruct);

  /* EXTI interrupt init*/
  HAL_NVIC_SetPriority(EXTI9_5_IRQn, 15, 15);
  HAL_NVIC_EnableIRQ(EXTI9_5_IRQn);
  HAL_NVIC_SetPriority(EXTI15_10_IRQn, 15, 15);
  HAL_NVIC_EnableIRQ(EXTI15_10_IRQn);

}
/* USER CODE BEGIN 4 */

void wheel(int8_t change) {
  uint8_t buffer[5];
  buffer[0] = 0x02;
  buffer[1] = 0;
  buffer[2] = 0;
  buffer[3] = 0;
  buffer[4] = change;
  USBD_HID_SendReport(&hUsbDeviceFS, buffer, sizeof(buffer));
  HAL_Delay(2*USBD_HID_GetPollingInterval(&hUsbDeviceFS));
}
void media(uint8_t change) {
  uint8_t buffer[2];
  buffer[0] = 0x03;
  buffer[1] = change;
  USBD_HID_SendReport(&hUsbDeviceFS, buffer, sizeof(buffer));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));
}
void changeDevice(void){
  const uint8_t buffshortcut[9] = {0x01,0x0a,0x00,0x04,0x00,0x00,0x00,0x00,0x00};
  const uint8_t buffEmpty[9] = {0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

  USBD_HID_SendReport(&hUsbDeviceFS, buffshortcut, sizeof(buffshortcut));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffEmpty, sizeof(buffEmpty));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

}
void runSpotify(void) {
  const uint8_t bufferwin[9] = {0x01,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
  const uint8_t buffer[9] = {0x01,0x00,0x00,0x16,0x13,0x12,0x17,0x0c,0x09};
  const uint8_t buffrun[9] = {0x01,0x00,0x00,0x28,0x00,0x00,0x00,0x00,0x00};
  const uint8_t buffEmpty[9] = {0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

  USBD_HID_SendReport(&hUsbDeviceFS, bufferwin, sizeof(bufferwin));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffEmpty, sizeof(buffEmpty));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffer, sizeof(buffer));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffrun, sizeof(buffrun));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffEmpty, sizeof(buffEmpty));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

}
void runChrome(void) {
  const uint8_t bufferwin[9] = {0x01,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
  const uint8_t buffer[9] = {0x01,0x00,0x00,0x06,0x0b,0x15,0x12,0x10,0x08};
  const uint8_t buffrun[9] = {0x01,0x00,0x00,0x28,0x00,0x00,0x00,0x00,0x00};
  const uint8_t buffEmpty[9] = {0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

  USBD_HID_SendReport(&hUsbDeviceFS, bufferwin, sizeof(bufferwin));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffEmpty, sizeof(buffEmpty));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffer, sizeof(buffer));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffrun, sizeof(buffrun));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffEmpty, sizeof(buffEmpty));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

}
void runCalc(void) {
  const uint8_t bufferwin[9] = {0x01,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
  const uint8_t buffer[9] = {0x01,0x00,0x00,0x0e,0x04,0x0f,0x0e,0x18,0x0f};
  const uint8_t buffrun[9] = {0x01,0x00,0x00,0x28,0x00,0x00,0x00,0x00,0x00};
  const uint8_t buffEmpty[9] = {0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

  USBD_HID_SendReport(&hUsbDeviceFS, bufferwin, sizeof(bufferwin));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffEmpty, sizeof(buffEmpty));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffer, sizeof(buffer));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffrun, sizeof(buffrun));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

  USBD_HID_SendReport(&hUsbDeviceFS, buffEmpty, sizeof(buffEmpty));
  HAL_Delay(5*USBD_HID_GetPollingInterval(&hUsbDeviceFS));

}
/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
void _Error_Handler(char * file, int line) {
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  while(1) {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef USE_FULL_ASSERT

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line) {
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */

/**
  * @}
*/

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
